import glob

import axipy
from axipy import Schema, provider_manager, Attribute, CoordSystem, Polygon, Feature


def getBound(table):
    cs=table.coordsystem
    size=table.size
    transform=table.device_to_scene_transform
    x0,y0=transform.map(0,0)
    x1,y1=transform.map(0,size.height())
    x2,y2=transform.map(size.width(),size.height())
    x3,y3=transform.map(size.width(),0)
    bound=Polygon([(x0,y0),(x1,y1),(x2,y2),(x3,y3)],cs)
    return bound
path_out_tab="E:\\Download\\Maps\\maps_97761461072696\\maps_97761461072696\\bounds_raster.tab"
cs_prj = CoordSystem.from_prj('1, 104')
schema = Schema(Attribute.string('path',254),coordsystem=cs_prj)
table_out = provider_manager.createfile(path_out_tab,schema)
''' Список всех файлов с расширение tab в стартовой директории и во всех вложенных'''
path_source_rasters="E:\\Download\\Maps\\maps_97761461072696\\maps_97761461072696\\"
list_tab= glob.glob(path_source_rasters + '/**/*.tab', recursive=True)
if len(list_tab)>0:
    for path_tab in list_tab:
        tab_raster=provider_manager.openfile(path_tab)
        if not isinstance(tab_raster,axipy.da.Raster):
            tab_raster.close()
            continue
        bound=getBound(tab_raster)
        tab_raster.close()
        feat = Feature({'path':path_tab}, geometry=bound)
        table_out.insert([feat])
        #break
    table_out.commit()
    table_out.close()
print("End")